; /////////////////////////////////////////////////////////////////////////
; CompSub.Asm Library File Compression Routine
; 2000 Cygnus X-1 Technologies
;
; You are not allowed to distribute a modified source file nor 
; the binary. Any changes must be for personal use only and be reported to:
; Julien Solignac <x1cygnus@online.fr>
; #########################################################################

CompSub:
	LD	HL, (Destination)
	PUSH	HL

	EXX
	LD	C, 00000001b
	EXX

	LD	HL, (Location)
	LD	BC, (FileSize)

CompSub_Loop:
	LD	A, (HL)
	EXX

	LD	L, A
	LD	H, 00h
	ADD	HL, HL
	ADD	HL, HL		; Times 4
	LD	DE, FastTranslationChart
	ADD	HL, DE
	LD	B, (HL)
	INC	HL
; HL = Bin Entry, B = Bit Size

	EX	DE, HL
	POP	HL
; Restore Destination

BinaryStringLp:
	LD	A, (DE)

BinaryStringSub:
	RLA
	RR	(HL)
; Destination Is Initialised To 10000000b, So We Get A Carry On Last Byte
	JP	C, CompSub_NextByte

CompSub_Return:
	RLC	C
	JP	C, CompSub_Aligned
	DEC	B
	JP	NZ, BinaryStringSub
	JP	CompSub_EndString

CompSub_NextByte:
	INC	HL
	DEC	IX
	JP	CompSub_Return

CompSub_Aligned:
	INC	DE
	DEC	B
	JP	NZ, BinaryStringSub

CompSub_EndString:
	PUSH	HL
; Preserve Destination

	EXX

	PUSH	IX
	POP	DE
	INC	D
	JP	Z, Error
; JP Takes 6 ClockCycles Less Than JR

	INC	HL
	DEC	BC
	LD	A, B
	OR	C
	JP	NZ, CompSub_Loop

	POP	HL
; Restore Destination
BitPadLp:
	RR	(HL)
	RET	C
	JR	BitPadLp
