; /////////////////////////////////////////////////////////////////////////
; ErrSub.Asm Library Error Handler
; 2000 Cygnus X-1 Technologies
;
; You are not allowed to distribute a modified source file nor 
; the binary. Any changes must be for personal use only and be reported to:
; Julien Solignac <x1cygnus@online.fr>
; #########################################################################

Err_Fatal:
	LD	HL, Mess_Fatal
	Invoke(_VPuts)
	Invoke(_GetKey)
	JP	4062h

Err_IO:
	Invoke(PopErr)
	LD	HL, Mess_IO
	Invoke(_VPuts)
	JR	ErrSub_Return

Err_DeMem:
	LD	HL, Main_EndOfFile
	LD	DE, 1024d
	Invoke(DeleteMem)
Err_Memory:
	Invoke(PopErr)
	LD	HL, Mess_Memory
	Invoke(_VPuts)
	JR	ErrSub_Return

ErrSub_UnExpected:
	Invoke(PopErr)
	Invoke(PopErr)
	LD	HL, Mess_UnExpected
	JR	ErrSub_CleanUp

ErrSub_Ratio:
	Invoke(PopErr)
	PUSH	IX
	POP	HL
	LD	DE, - SafeBytes
	Invoke(_CPHLDE)
	JR	C, Err_Fatal
	LD	HL, Mess_Ratio

ErrSub_CleanUp:
	Invoke(_VPuts)
	CALL	FileSub_CleanUp
ErrSub_Return:
	JMP(_GetKey)
