; /////////////////////////////////////////////////////////////////////////
; FileSub.Asm Library File Handler
; 2000 Cygnus X-1 Technologies
;
; You are not allowed to distribute a modified source file nor 
; the binary. Any changes must be for personal use only and be reported to:
; Julien Solignac <x1cygnus@online.fr>
; #########################################################################

FileSub:
; File Header Format:
; /------------------------------------------------------------\
; | XZip | # Bytes | Size Until Data | FileSize | Bytes | Mask |
; \------------------------------------------------------------/
; 0      4         6                 8         10      12     14       
	LD	HL, TempName
	RST	20h

	LD	HL, (FileSize)
	PUSH	HL
	POP	IX
	DEC	IX

	Invoke(NewProg)

	EX	DE, HL
	INC	HL
	INC	HL

	LD	(DestinationHeader), HL

	LD	(HL), LChi
	INC	HL
	LD	(HL), 'Z'
	INC	HL
	LD	(HL), 'i'
	INC	HL
	LD	(HL), 'p'
	INC	HL
; Write Headers...

	LD	DE, (CatalogedBytes)
	LD	D, 00h
	DEC	E
	INC	DE
	PUSH	DE
; Preserve CatalogedBytes

	LD	(HL), D
	INC	HL
	LD	(HL), E
	INC	HL
; Write #Bytes

	PUSH	HL
; Preserve Destination

	LD	HL, 000Ah
	ADD	HL, DE
	LD	DE, (BitMaskLength)
	ADD	HL, DE
	EX	DE, HL
; DE = Header Size (#Bytes + BitMask + Other Info)

	PUSH	IX
	POP	HL

	PUSH	DE
	LD	DE, - SafeBytes
	ADD	HL, DE
	POP	DE
; Safe Bytes Margin
	OR	A
	SBC	HL, DE
	JP	C, Error
	PUSH	HL
	POP	IX

	POP	HL
; Restore Destination

	LD	(HL), D
	INC	HL
	LD	(HL), E
	INC	HL
; Write Size Until Header

	LD	DE, (FileSize)
	LD	(HL), D
	INC	HL
	LD	(HL), E
	INC	HL
; Write Decompressed Size
; Now HL Ready To Recieve Bytes In Order
	EX	DE, HL

	POP	BC
; Restore Cataloged Bytes
	LD	HL, BitMaskGenerationChart
	LDIR
; Write Bytes

	LD	BC, (BitMaskLength)
	LD	HL, BitMaskStorage
	LDIR
; Write BitMask

	EX	DE, HL

	PUSH	IX
	POP	BC
	LD	A, B
	OR	C
	JP	Z, Error

	LD	(Destination), HL
	PUSH	HL
	POP	DE
	INC	DE
	LD	(HL), 10000000b
	LDIR

; // - Sub Function - //
FileSub_UpdateLocation:
FileNameBuffer	EQU	$ + 01h
	LD	HL, 0000h
	RST	20h
	Invoke(_ChkFindSym)
	JP	C, Err_Fatal

	INC	DE
	INC	DE
	LD	(Location), DE
	RET

; // - Sub Function - //
FileSub_CleanUp:
	LD	BC, (StrucTableTotalEntrys)
	LD	HL, 2048d + 64d
	LD	DE, 0007h
LeakClear:
	ADD	HL, DE
	DEC	BC
	LD	A, B
	OR	C
	JR	NZ, LeakClear
	EX	DE, HL

	LD	HL, Main_EndOfFile
	Invoke(DeleteMem)

	LD	HL, TempName
	RST	20h
	Invoke(_ChkFindSym)
	JP	C, Err_Fatal
	JMP(_DelVar)

TempName:
	.DB	05h, "TMPX", NULL
