; /////////////////////////////////////////////////////////////////////////
; FreqSub.Asm Libary Frequency Chart Builder
; 2000 Cygnus X-1 Technologies
;
; You are not allowed to distribute a modified source file nor 
; the binary. Any changes must be for personal use only and be reported to:
; Julien Solignac <x1cygnus@online.fr>
; #########################################################################

;      -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; -==-==- File Frequency Analyser -==-==-
;      -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; This Will Scan The Entire File Building A Frequency Chart That Must
; Be Transcribed Later

; This Must Be Defined If Debugging
; #Define Debug

#IfDef Debug
.NOLIST
#DEFINE equ .equ
#DEFINE EQU .equ
#DEFINE end .end
#INCLUDE "TI83ASM.INC"
#INCLUDE "TOKENS.INC"
#INCLUDE "CYGNUS.INC"

.LIST
.ORG	9327h

#EndIf

; Fast Chart Will Be Stored At 8600h For Practical Reasons

FreqSub:

#IfDef Debug
	LD	HL, TestChart
#EndIf

	PUSH	HL
; Preserve File Address

	LD	BC, 00FFh * 02h
	LD	HL, FastChart

	PUSH	HL
; Preserve FastChart Address

	LD	(HL), 00h
	LD	DE, FastChart + 01h
	LDIR
; Zero Out Our Frequency Chart

	POP	DE
; Restore FastChart Address

	POP	HL
; Restore File Address


#IfNDef Debug
	LD	BC, (FileSize)
#Else
	LD	BC, FileSize
#EndIf


FstChartLp:
	PUSH	HL
; Preserve In File Address

	LD	L, (HL)
	LD	H, 86h / 02h
; This Saves A Bit Of Time And Space,
	ADD	HL, HL
; Now HL = Address Of Chart Pointer To Increment

; Warning: Here LSB Is First Byte!
	INC	(HL)
	JR	NZ, FreqNotSupFF
	INC	HL
	INC	(HL)
FreqNotSupFF:

	POP	HL
; Restore In File Address

	INC	HL
	DEC	BC
	LD	A, B
	OR	C
	JR	NZ, FstChartLp

#IfNDef Debug
	RET
#Else
	CALL	_GETKEY
	JP	4062h
#EndIf

#IfDef Debug
TestChart:
	.DB	00h, 01h, 02h, 03h, 04h, 05h, 06h, 07h
	.DB	08h, 09h, 0Ah, 0Bh, 0Ch, 0Dh, 0Eh, 0Fh
	.DB	01h, 01h, 01h, 01h, 01h, 01h, 01h, 01h
	
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
	.DB	02h, 02h, 02h, 02h, 02h, 02h, 02h, 02h
EndTestChart:
#Define FileSize	EndTestChart - TestChart
#EndIf


#IfDef Debug
.END
END

#EndIf
