; /////////////////////////////////////////////////////////////////////////
; MaskSub.Asm Library Bit Mask Generator For XAlgo
; 2000 Cygnus X-1 Technologies
;
; You are not allowed to distribute a modified source file nor 
; the binary. Any changes must be for personal use only and be reported to:
; Julien Solignac <x1cygnus@online.fr>
; #########################################################################

MaskSub:
; Here We Create The Famous BitMask
	LD	DE, BitMaskGenerationChart
	PUSH	DE
	POP	IX
	LD	HL, BitMaskStorage

	PUSH	HL
; Preserve Storage Area

	LD	A, (CatalogedBytes)
	LD	B, A
; Once All Numbers Are Locked In Place, We No Longer Need To Continue

	LD	C, 00000001b
; Normally We Should Go From Right To Left, But Since Jimmy Mardel Does
; It The Other Way Round We Might As Well Do The Same So Like That We Have
; A Free PC Compressor.

BitMaskLp:
	LD	A, (DE)
	OR	A
; If Byte = 00h Then It's A Byte, And Byte = 0
	JR	NZ, BitPointer

	INC	DE
	LD	A, (DE)
	DEC	DE
	LD	(IX + 00h), A
	INC	IX

; The BitMask Storage Area Is Initialised To 0FFh
; So We Should XOR Bytes To Eliminate Them
	LD	A, C
	XOR	(HL)
	LD	(HL), A

	DEC	B
	JR	Z, MaskSub_Exit

BitPointer:
	INC	DE
	INC	DE

	RLC	C
	JR	NC, BitMaskLp

	INC	HL
	JR	BitMaskLp

MaskSub_Exit:
	POP	DE
	OR	A
	SBC	HL, DE
	INC	HL
	LD	(BitMaskLength), HL

	RET
