; /////////////////////////////////////////////////////////////////////////
; SortSub.Asm Sort Routine
; 2000 Cygnus X-1 Technologies
;
; You are not allowed to distribute a modified source file nor 
; the binary. Any changes must be for personal use only and be reported to:
; Julien Solignac <x1cygnus@online.fr>
; #########################################################################

;      -=-=--=-=-=-=-=-=-=-=-=-
; -==-==-  Sort Algorithem -==-==-
;      -=-=--=-=-=-=-=-=-=-=-=-
; This Sorts The Tree Structure By Decending Order

; This Must Be Defined If Debugging
;#IfNDef	XDebug
;#Define Debug
;#EndIf

#IfDef Debug
.NOLIST
#DEFINE equ .equ
#DEFINE EQU .equ
#DEFINE end .end
#INCLUDE "TI83ASM.INC"
#INCLUDE "TOKENS.INC"
#INCLUDE "CYGNUS.INC"

DataArea			EQU	StatVars
NextReservedNumberSpace		EQU	DataArea + 0000h
SortIterations			EQU	DataArea + 0002h
NumberInAnalysis		EQU	DataArea + 0004h

.LIST
.ORG	9327h

	CALL	Sort
	CALL	_GETKEY
	JP	4062h

#EndIf

Sort:

#IfNDef	Debug
	LD	HL, (Structure)
#Else
	LD	HL, Structure
#EndIf
	LD	(NextReservedNumberSpace), HL

#IfNDef	Debug
	LD	HL, (StrucTablePtrEntrys)
#Else
	LD	HL, (EndOfStructure - Structure) / 07h
#EndIf

	LD	(SortIterations), HL
; Could Be Optimised...

#IfNDef	Debug
	LD	HL, (StrucTablePtrEnd)
#Else
	LD	HL, EndOfStructure
#EndIf

	LD	(NumberInAnalysis), HL

SortOVLp:
	LD	BC, (SortIterations)
	DEC	BC
	LD	A, B
	OR	C
	RET	Z

	LD	HL, 0000h
	PUSH	HL

#IfNDef Debug
	LD	HL, (StrucTablePtrEnd)
#Else
	LD	HL, EndOfStructure
#EndIf

	LD	(SortIterations), BC
	INC	BC

SortLp:
	LD	DE, 0000h - 0007h
	ADD	HL, DE

	LD	E, (HL)
	INC	HL
	LD	D, (HL)
	DEC	HL

	EX	(SP), HL
	Invoke(_CPHLDE)

	JR	C, NumberIsLarger

	EX	(SP), HL

	DEC	BC
	LD	A, B
	OR	C
	JP	NZ, SortLp

	JR	FinishedSorting

NumberIsLarger:
	POP	HL
	PUSH	DE

	LD	(NumberInAnalysis), HL
	DEC	BC
	LD	A, B
	OR	C
	JP	NZ, SortLp

FinishedSorting:
	POP	AF

	LD	HL, (NextReservedNumberSpace)
	LD	DE, (NumberInAnalysis)
	LD	BC, 07FFh

SwapLp:
	LD	A, (DE)
	LDI
	DEC	HL
	LD	(HL), A
	INC	HL
	DJNZ	SwapLp

	LD	(NextReservedNumberSpace), HL
	JP	SortOvLp

#IfDef	Debug
	.DB	"Begin", 0FFh
Structure:
; Freq, Value, Ptr 1, Ptr 2
	.DW	0003h
	.DB	00h
	.DW	0000h, 0005h
	
	.DW	0004h
	.DB	03h
	.DW	0000h, 0000h
	
	.DW	0003h
	.DB	09h
	.DW	0000h, 0000h
	
	.DW	0002h
	.DB	0FFh
	.DW	0000h, 0000h
	
	.DW	0001h
	.DB	04h
	.DW	0000h, 0000h
EndOfStructure:

END
.END
#EndIf
