; /////////////////////////////////////////////////////////////////////////
; UpDatSub.Asm Pointer Update Routine For XAlgo
; 2000 Cygnus X-1 Technologies
;
; You are not allowed to distribute a modified source file nor 
; the binary. Any changes must be for personal use only and be reported to:
; Julien Solignac <x1cygnus@online.fr>
; #########################################################################

;      -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; -==-==- Structure Pointer Update -==-==-
;      -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; This Will Scan The Structure And Every Valid Pointer
; Will Be Incremented

; This Must Be Defined If Debugging
;#IfNDef	XDebug
;#Define Debug
;#EndIf

#IfDef Debug
.NOLIST
#DEFINE equ .equ
#DEFINE EQU .equ
#DEFINE end .end
#INCLUDE "TI83ASM.INC"
#INCLUDE "TOKENS.INC"
#INCLUDE "CYGNUS.INC"

.LIST
.ORG	9327h

#EndIf

PtrUpdate:

#IfNDef	Debug
	LD	HL, (Structure)
#Else
	LD	HL, Structure
#EndIf

#IfNDef	Debug
	LD	BC, (StrucTableTotalEntrys)
#Else
	LD	BC, (EndOfStructure - Structure) / 07h
#EndIf

; 0      2       3   4   5       7
; /------------------------------\
; | Freq | Value | Ptr 1 | Ptr 2 |
; \------------------------------/
;                 LSB MSB

	LD	DE, 0004h
	ADD	HL, DE
; Now HL = Ptr 1

UpDateLp:
	LD	A, (HL)
	OR	A
; If Most Signifiant Byte Is Cleared, Then Isn't Ptr
	JR	Z, SkipEntry

	DEC	HL
	CALL	UpDatAdd
	CALL	UpDatAdd

	LD	DE, 0004h
	JR	OverSkipEntry

UpDatAdd:
	PUSH	HL

	LD	A, (HL)
	INC	HL
	LD	H, (HL)
	LD	L, A

	LD	DE, 0007h
	ADD	HL, DE

	EX	(SP), HL
	POP	DE
	LD	(HL), E
	INC	HL
	LD	(HL), D
	INC	HL
	RET

SkipEntry:
	LD	DE, 0007h
OverSkipEntry:
	ADD	HL, DE
	DEC	BC
	LD	A, B
	OR	C
	JR	NZ, UpDateLp

#IfNDef	Debug
	RET
#Else
	CALL	_GETKEY
	JP	4062h
#EndIf

#IfDef	Debug
	.DB	"Begin", 0FFh
Structure:
	.DW	0000h
	.DB	01h
	.DW	0107h, 0000h

	.DW	0000h
	.DB	02h
	.DW	0000h, 0000h
	
	.DW	0000h
	.DB	03h
	.DW	0101h, 0002h
EndOfStructure:

END
.END
#EndIf
