; /////////////////////////////////////////////////////////////////////////
; XTreeSub.Asm Binary Tree Builder
; 2000 Cygnus X-1 Technologies
;
; You are not allowed to distribute a modified source file nor 
; the binary. Any changes must be for personal use only and be reported to:
; Julien Solignac <x1cygnus@online.fr>
; #########################################################################

; This Must Be Defined If Debugging
;#Define XDebug

#IfDef XDebug
.NOLIST
#DEFINE equ .equ
#DEFINE EQU .equ
#DEFINE end .end
#INCLUDE "TI83ASM.INC"
#INCLUDE "TOKENS.INC"
#INCLUDE "CYGNUS.INC"


; For Main Module
DatArea				EQU	StatVars
StrucTablePtrEntrys		EQU	DatArea + 0000h
StrucTablePtrEnd		EQU	DatArea + 0002h

; For Sort Sub Module
NextReservedNumberSpace		EQU	DatArea + 0004h
SortIterations			EQU	DatArea + 0006h
NumberInAnalysis		EQU	DatArea + 0008h

; For Add & UpDat Sub Module
StrucTableTotalEntrys		EQU	DatArea + 000Ah
StrucTableTotalEnd		EQU	DatArea + 000Ch

Structure			EQU	DatArea + 000Eh

.LIST
.ORG	9327h

#EndIf

#IfDef	XDebug
	LD	HL, XStructure
	LD	(Structure), HL

	LD	HL, (EndOfStructure - XStructure) / 07h
	LD	(StrucTablePtrEntrys), HL
	LD	(StrucTableTotalEntrys), HL
	
	LD	HL, EndOfStructure
	LD	(StrucTablePtrEnd), HL
	LD	(StrucTableTotalEnd), HL

	CALL	XTree
	CALL	_GETKEY
	JP	4062h
#EndIf

XTreeSub:
	LD	HL, (StrucTablePtrEntrys)
	DEC	HL
	LD	(StrucTablePtrEntrys), HL
XTreeLp:
	LD	HL, (StrucTablePtrEnd)

	LD	DE, 0000h - 0007h
	ADD	HL, DE

	PUSH	HL
; Preserve Low Freq Ptr

	LD	(StrucTablePtrEnd), HL
; Lets Get Lowest Frequence(Left Entry)
	CALL	GetHL

	EX	(SP), HL
; Exchange Vars, (SP) = Low Freq Value | HL= Low Freq Ptr
	LD	(LowFreq), HL

	CALL	ZeroIt
; Destroy LF Leaf

	ADD	HL, DE
; SubStract 0007h --> Next Leaf

	LD	(HighFreq), HL

	LD	E, (HL)
	LD	(HL), 00h
	INC	HL
	LD	D, (HL)
	LD	(HL), 00h
; Now DE = High Frequence Value

	POP	HL
; Restore Low Frequence Value
	ADD	HL, DE

	LD	(Frequence), HL

	CALL	AddStructure

	EX	DE, HL
	LD	HL, XTree_Buffer + 0006h
	LD	BC, 0007h
	LDDR

	CALL	PtrUpdate

	LD	HL, (StrucTablePtrEntrys)
	DEC	HL
	LD	A, H
	OR	L
	RET	Z
	LD	(StrucTablePtrEntrys), HL

#Include	"../Source/XAlgo/Lib/XSortSub.Asm"

	JP	XTreeLp

ZeroIt:
	LD	(HL), 00h
	INC	HL
	LD	(HL), 00h
	DEC	HL
	RET
GetHL
	LD	A, (HL)
	INC	HL
	LD	H, (HL)
	LD	L, A
	RET


#IfDef XDebug
; ### Temp ###
	.DB	"Temp", 0FFh
TempStructure:
Frequence:
	.DW	0000h
	.DB	00h
LowFreq:
	.DW	0000h
HighFreq:
	.DW	0000h
TempStructureEnd:
; ### #### ###

#Include	"../Source/SortSub.Asm"
#Include	"../Source/@online.fr.Asm"
#Include	"../Source/UpDatSub.Asm"

	.DB	"Begin", 0FFh
XStructure:
	.DW	0004h
	.DB	04h
	.DW	0000h, 0000h
	
	.DW	0003h
	.DB	03h
	.DW	0000h, 0000h

	.DW	0002h
	.DB	02h
	.DW	0000h, 0000h
	
	.DW	0001h
	.DB	01h
	.DW	0000h, 0000h
EndOfStructure:
	.DB	0FFh, "End"

END
.END
#EndIf
	