#Include "x1Cygnus.Inc"
; ////////////////////////
; //---- Code Begin ----//
; ////////////////////////

	XOR	A
	JR	NC, SkipDescr
xTitle		.DB		LChi, "Zip v1.0 - ", LChi, LInverse, "Cygnus", NULL
SkipDescr:

Reset:
	SET	TextWrite, (IY + SGRFLAGS)

Initialise:
	CALL	ResetFilePointer

ResetFiles:
	CALL	ListFiles

LpKey:
	Invoke(BufCopy)
	Invoke(_GetKey)
	LD	HL, Selected

	CP	KeyRight
	JR	Z, ResetFiles
	CP	KeyDown
	JR	Z, DownKey
	CP	KeyUp
	JR	Z, UpKey
	CP	KeyEnter
	JR	Z, Execute
	RET

Execute:
	LD	L, (HL)
	LD	H, 08h
	Invoke(_HTimesL)
	LD	DE, XFileNameBuffer
	ADD	HL, DE
	LD	(FileNameBuffer), HL

	Invoke(ClearPlots)
	CALL	Header
	Invoke(BufCopy)
	RES	TextWrite, (IY + SGRFLAGS)

	CALL	XAlgo
	JR	Reset

UpKey:
	LD	A, (HL)
	OR	A
	JR	NZ, SkipKeyAdjust
	LD	A, (MarkMax)
SkipKeyAdjust:
	DEC	A

CommonKeyCode:	
	PUSH	HL
	PUSH	AF
	CALL	Invert
	POP	AF
	POP	HL
	LD	(HL), A
	CALL	Invert
	JR	LpKey

DownKey:
	LD	A, (HL)
	INC	A
MarkMax		EQU	$ + 1
	CP	NULL
	JR	NZ, CommonKeyCode
	XOR	A
	JR	CommonKeyCode
	RET

; [--// Sub Function //--]
Header:
	Invoke(ClearPlots)
; Clear Screen
	LD	HL, 0000h
	LD	(PENCOL), HL
	LD	HL, xTitle
	Invoke(_VPuts)
	LD	HL, PlotScreen + (06h * 0Ch)
	LD	B, 0Ch
	JR	InverseText


; [--// Sub Function //--]
Invert:
Selected	EQU	$ + 1
	LD	L, 00h
	LD	H, 06h * 0Ch
	Invoke(_HTimesL)
	LD	DE, PlotScreen + (07h * 0Ch)
	ADD	HL, DE
	LD	B, 07h * 0Ch
InverseText:
	LD	A, (HL)
	CPL
	LD	(HL), A
	INC	HL
	DJNZ	InverseText
	RET

; [--// Sub Function //--]
ListFiles:
	XOR	A
	LD	(Selected), A
; Reset HighLight
	CALL	Header
	LD	HL, PlotScreen + (0Ch * 08h)
	LD	(IconPointer), HL
; Setup Zip Marker
	LD	HL, 0707h
	LD	(PENCOL), HL
; Setup Text Pointers
	LD	DE, XFileNameBuffer
	LD	B, DisplayFiles
	CALL	ListLp
	LD	A, DisplayFiles
	CP	B
	JR	NZ, ListFilesContinue
	CALL	ResetFilePointer
	JR	ListFiles

ListFilesContinue:
	LD	A, DisplayFiles
	SUB	B
	LD	(MarkMax), A
	JP	Invert

ListLp:
	PUSH	BC
	CALL	ListFile
	POP	BC
	RET	NZ
	DJNZ	ListLp
	RET

ListFile:
	CALL	FindFile
	RET	NZ

	PUSH	DE
	PUSH	DE
SaveFileAddr	EQU	$+1
	LD	HL, 0000h
	INC	HL
	INC	HL

	LD	A, (HL)
	INC	HL
	LD	C, (HL)

IconPointer	EQU	$ + 1
	LD	HL, 0000h
	LD	B, 06h * 0Ch
; Icon Info

	CP	LChi
	JR	NZ, NotZip
	LD	A, C
	CP	'Z'
	JR	NZ, NotZip

	LD	DE, Iconx
	LD	BC, 050Ch

WriteIcon:
	LD	A, (DE)
	LD	(HL), A
	INC	DE

	PUSH	BC
	LD	B, 00h
	ADD	HL, BC
	POP	BC
	DJNZ	WriteIcon
	LD	B, 01h * 0Ch

NotZip:
	INC	HL
	DJNZ	NotZip

SkipIconUpdate:
	LD	(IconPointer), HL

	POP	HL
	Invoke(_VPuts)
	LD	A, (PENROW)
	LD	HL, 0607h
	ADD	A, H
	LD	H, A
	LD	(PENCOL), HL
	POP	DE
	LD	HL, 0008h
	ADD	HL, DE
	EX	DE, HL
	CP	A
	RET

; [--// Sub Function //--]
ResetFilePointer:
	LD	HL, (ProgPtr)
	LD	(LstPointer), HL
	RET

; ### Includes ###
#Include	"../Source/XZip/ZipEqu.Asm"
#Include	"../Source/XZip/ZipFind.Asm"

; ################################################
; ######### XAlgo (De)Compression Motor ##########
; ################################################
#Include	"../Source/XAlgo/XAlgoLib.Asm"

END
.END
